Index: src/isdn/Q931ie.c
===================================================================
--- src/isdn/Q931ie.c	(revision 495)
+++ src/isdn/Q931ie.c	(working copy)
@@ -70,13 +70,12 @@
 *****************************************************************************/
 #define Q931MoreIE() (Octet+Off - 2 < IESize)
 
-#define Q931IESizeTest(x)   {\
-                            if(Octet+Off-2 != IESize)\
-                            {\
-                                Q931SetError(pTrunk,x, Octet, Off);\
-                                return x;\
-                            }\
-                            }
+#define Q931IESizeTest(x) {\
+		if(Octet+Off-2 != IESize) {\
+			Q931SetError(pTrunk,x, Octet, Off);\
+			return x;\
+		}\
+	}
 
 /*****************************************************************************
 
@@ -100,7 +99,7 @@
 
 L3INT Q931ReadExt(L3UCHAR * IBuf, L3INT Off)
 {
-    L3INT c =0;
+    L3INT c = 0;
     while((IBuf[c] & 0x80) == 0)
         c++;
 
@@ -128,171 +127,165 @@
 
 L3INT Q931Uie_BearerCap(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *pMsg, L3UCHAR * IBuf, L3UCHAR * OBuf, L3INT *IOff, L3INT *OOff) 
 {
-    Q931ie_BearerCap * pie = (Q931ie_BearerCap*)OBuf;
+	Q931ie_BearerCap *pie = (Q931ie_BearerCap*)OBuf;
 	ie *pIE = &pMsg->BearerCap;
-    L3INT Off = 0;
-    L3INT Octet = 0;
-    L3INT IESize;
-    *pIE=0;
+	L3INT Off = 0;
+	L3INT Octet = 0;
+	L3INT IESize;
+	*pIE=0;
 
-    /* Octet 1 */
-    pie->IEId        = IBuf[Octet];
-    Octet ++;
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Decoding Bearer Capability IE\n");
 
-    /* Octet 2 */
-    IESize = IBuf[Octet ++]; 
+	/* Octet 1 */
+	pie->IEId = IBuf[Octet++];
 
-    /* Octet 3 */
-    pie->CodStand    = ieGetOctet((IBuf[Octet] & 0x60) >> 5);
-    pie->ITC         = ieGetOctet(IBuf[Octet] & 0x1f);
-    Off = Q931ReadExt(&IBuf[Octet], Off);
-    Octet++;
+	/* Octet 2 */
+	IESize    = IBuf[Octet++]; 
 
-    /* Octet 4 */
-    pie->TransMode   = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
-    pie->ITR         = ieGetOctet(IBuf[Octet+Off] & 0x1f);
-    Off = Q931ReadExt(&IBuf[Octet+Off], Off);
-    Octet++;
+	/* Octet 3 */
+	pie->CodStand = ieGetOctet((IBuf[Octet] & 0x60) >> 5);
+	pie->ITC      = ieGetOctet(IBuf[Octet] & 0x1f);
+	Off = Q931ReadExt(&IBuf[Octet], Off);
+	Octet++;
 
-    /* Octet 4.1. Rate multiplier is only present if ITR = Multirate        */
-    if(pie->ITR == 0x18)
-    {
-        pie->RateMul = ieGetOctet(IBuf[Octet+Off] & 0x7f);
-        Off = Q931ReadExt(&IBuf[Octet+Off], Off);
-        Off ++;
-    }
+	/* Octet 4 */
+	pie->TransMode = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
+	pie->ITR       = ieGetOctet(IBuf[Octet+Off] & 0x1f);
+	Off = Q931ReadExt(&IBuf[Octet+Off], Off);
+	Octet++;
 
-    /* Octet 5 */
-    if((IBuf[Octet+Off] & 0x60) == 0x20 && Q931MoreIE())
-    {
-        pie->Layer1Ident = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
-        pie->UIL1Prot    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
-        Octet++;
+	/* Octet 4.1. Rate multiplier is only present if ITR = Multirate        */
+	if(pie->ITR == 0x18)
+	{
+		pie->RateMul = ieGetOctet(IBuf[Octet+Off] & 0x7f);
+		Off = Q931ReadExt(&IBuf[Octet+Off], Off);
+		Off++;
+	}
 
-        /* Octet 5a. The octet may be present if ITC is unrestrictd digital info*/
-        /* and UIL1Prot is either V.110, I.460 and X.30 or V.120. It may also   */
-        /* be present if ITC = 3.1 kHz audio and UIL1Prot is G.711.             */
-        /* Bit 8 of Octet 5 = 0 indicates that 5a is present.                   */
+	/* Octet 5 */
+	if((IBuf[Octet+Off] & 0x60) == 0x20 && Q931MoreIE())
+	{
+		pie->Layer1Ident = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
+		pie->UIL1Prot    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
+		Octet++;
 
-        if(IsQ931Ext(IBuf[Octet+Off-1]))
-        {
-            if(((pie->ITC == 0x08) && (pie->UIL1Prot == 0x01 || pie->UIL1Prot == 0x08))
-            || ((pie->ITC == 0x10) && (pie->UIL1Prot == 0x02 || pie->UIL1Prot == 0x03)))
-            {
-                pie->SyncAsync   = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
-                pie->Negot       = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 5);
-                pie->UserRate    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
-                Off ++;
-            }
-            else
-            {
-                /* We have detected bit 8 = 0, but no setting that require the  */
-                /* additional octets ???                                        */
-                Q931SetError(pTrunk, Q931E_BEARERCAP, 5,Off);
-                return Q931E_BEARERCAP;
-            }
+		/* Octet 5a. The octet may be present if ITC is unrestrictd digital info*/
+		/* and UIL1Prot is either V.110, I.460 and X.30 or V.120. It may also   */
+		/* be present if ITC = 3.1 kHz audio and UIL1Prot is G.711.             */
+		/* Bit 8 of Octet 5 = 0 indicates that 5a is present.                   */
 
-            /* Octet 5b. Two different structures used.                         */
-            if(IsQ931Ext(IBuf[Octet+Off-1]))
-            {
-                if(pie->UIL1Prot == 0x01) /* ITU V.110, I.460 and X.30           */
-                {
-                    pie->InterRate   = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
-                    pie->NIConTx     = ieGetOctet((IBuf[Octet+Off] & 0x10) >> 4);
-                    pie->NIConRx     = ieGetOctet((IBuf[Octet+Off] & 0x08) >> 3);
-                    pie->FlowCtlTx   = ieGetOctet((IBuf[Octet+Off] & 0x04) >> 2);
-                    pie->FlowCtlRx   = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 1);
-                    Off++;
-                }
-                else if(pie->UIL1Prot == 0x08) /* ITU V.120                      */
-                {
-                    pie->HDR         = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
-                    pie->MultiFrame  = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 5);
-                    pie->Mode        = ieGetOctet((IBuf[Octet+Off] & 0x10) >> 4);
-                    pie->LLInegot    = ieGetOctet((IBuf[Octet+Off] & 0x08) >> 3);
-                    pie->Assignor    = ieGetOctet((IBuf[Octet+Off] & 0x04) >> 2);
-                    pie->InBandNeg   = ieGetOctet((IBuf[Octet+Off] & 0x02) >> 1);
-                    Off++;
-                }
-                else
-                {
-                    Q931SetError(pTrunk,Q931E_BEARERCAP, 5,Off);
-                    return Q931E_BEARERCAP;
+		if(IsQ931Ext(IBuf[Octet+Off-1]))
+		{
+			if(((pie->ITC == 0x08) && (pie->UIL1Prot == 0x01 || pie->UIL1Prot == 0x08)) ||
+			   ((pie->ITC == 0x10) && (pie->UIL1Prot == 0x02 || pie->UIL1Prot == 0x03)))
+			{
+				pie->SyncAsync   = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
+				pie->Negot       = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 5);
+				pie->UserRate    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
+				Off++;
+			}
+			else {
+				/* We have detected bit 8 = 0, but no setting that require the  */
+				/* additional octets ???                                        */
+				Q931SetError(pTrunk, Q931E_BEARERCAP, 5,Off);
+				return Q931E_BEARERCAP;
+			}
 
-                }
+			/* Octet 5b. Two different structures used.                         */
+			if(IsQ931Ext(IBuf[Octet+Off-1]))
+			{
+				if(pie->UIL1Prot == 0x01) /* ITU V.110, I.460 and X.30           */
+				{
+					pie->InterRate   = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
+					pie->NIConTx     = ieGetOctet((IBuf[Octet+Off] & 0x10) >> 4);
+					pie->NIConRx     = ieGetOctet((IBuf[Octet+Off] & 0x08) >> 3);
+					pie->FlowCtlTx   = ieGetOctet((IBuf[Octet+Off] & 0x04) >> 2);
+					pie->FlowCtlRx   = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 1);
+					Off++;
+				}
+				else if(pie->UIL1Prot == 0x08) /* ITU V.120                      */
+				{
+					pie->HDR         = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
+					pie->MultiFrame  = ieGetOctet((IBuf[Octet+Off] & 0x20) >> 5);
+					pie->Mode        = ieGetOctet((IBuf[Octet+Off] & 0x10) >> 4);
+					pie->LLInegot    = ieGetOctet((IBuf[Octet+Off] & 0x08) >> 3);
+					pie->Assignor    = ieGetOctet((IBuf[Octet+Off] & 0x04) >> 2);
+					pie->InBandNeg   = ieGetOctet((IBuf[Octet+Off] & 0x02) >> 1);
+					Off++;
+				}
+				else {
+					Q931SetError(pTrunk,Q931E_BEARERCAP, 5,Off);
+					return Q931E_BEARERCAP;
+				}
 
-                /* Octet 5c */
-                if(IsQ931Ext(IBuf[Octet+Off-1]))
-                {
+				/* Octet 5c */
+				if(IsQ931Ext(IBuf[Octet+Off-1]))
+				{
+					pie->NumStopBits = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
+					pie->NumDataBits = ieGetOctet((IBuf[Octet+Off] & 0x18) >> 3);
+					pie->Parity      = ieGetOctet(IBuf[Octet+Off] & 0x07);
+					Off++;
 
-                    pie->NumStopBits = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
-                    pie->NumDataBits = ieGetOctet((IBuf[Octet+Off] & 0x18) >> 3);
-                    pie->Parity      = ieGetOctet(IBuf[Octet+Off] & 0x07);
-                    Off++;
+					/* Octet 5d */
+					if(IsQ931Ext(IBuf[Octet+Off-1]))
+					{
+						pie->DuplexMode  = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
+						pie->ModemType   = ieGetOctet(IBuf[Octet+Off] & 0x3f);
+						Off++;
+					}
+				}
+			}
+		}
+	}
 
-                    /* Octet 5d */
-                    if(IsQ931Ext(IBuf[Octet+Off-1]))
-                    {
+	/* Octet 6 */
+	if((IBuf[Octet+Off] & 0x60) == 0x40 && Q931MoreIE())
+	{
+		pie->Layer2Ident = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
+		pie->UIL2Prot    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
 
-                        pie->DuplexMode  = ieGetOctet((IBuf[Octet+Off] & 0x40) >> 6);
-                        pie->ModemType   = ieGetOctet(IBuf[Octet+Off] & 0x3f);
-                        Off ++;
-                    }
-                }
-            }
-        }
-    }
+		Off = Q931ReadExt(&IBuf[Octet+Off], Off);
+		Octet++;
+	}
 
-    /* Octet 6 */
-    if((IBuf[Octet+Off] & 0x60) == 0x40 && Q931MoreIE())
-    {
-        pie->Layer2Ident = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
-        pie->UIL2Prot    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
+	/* Octet 7 */
+	if((IBuf[Octet+Off] & 0x60) == 0x60 && Q931MoreIE()) 
+	{
+		pie->Layer3Ident = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
+		pie->UIL3Prot    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
+		Octet++;
 
-        Off = Q931ReadExt(&IBuf[Octet+Off], Off);
-        Octet ++;
-    }
+		/* Octet 7a */
+		if(IsQ931Ext(IBuf[Octet+Off-1]))
+		{
+			if(pie->UIL3Prot == 0x0c)
+			{
+				pie->AL3Info1 = ieGetOctet(IBuf[Octet+Off] & 0x0f);
+				Off++;
 
-    /* Octet 7 */
-    if((IBuf[Octet+Off] & 0x60) == 0x60 && Q931MoreIE()) 
-    {
-        pie->Layer3Ident = ieGetOctet((IBuf[Octet+Off] & 0x60) >> 5);
-        pie->UIL3Prot    = ieGetOctet(IBuf[Octet+Off] & 0x1f);
-        Octet++;
+				/* Octet 7b */
+				if(IsQ931Ext(IBuf[Octet+Off]))
+				{
+					pie->AL3Info2 = ieGetOctet(IBuf[Octet+Off] & 0x0f);
+					Off++;
+				}
+			}
+			else {
+				Q931SetError(pTrunk,Q931E_BEARERCAP, 7, Off);
+				return Q931E_BEARERCAP;
+			}
+		}
+	}
 
-        /* Octet 7a */
-        if(IsQ931Ext(IBuf[Octet+Off-1]))
-        {
-            if(pie->UIL3Prot == 0x0c)
-            {
-                pie->AL3Info1 = ieGetOctet(IBuf[Octet+Off] & 0x0f);
-                Off++;
+	Q931IESizeTest(Q931E_BEARERCAP);
 
-                /* Octet 7b */
-                if(IsQ931Ext(IBuf[Octet+Off]))
-                {
-                    pie->AL3Info2 = ieGetOctet(IBuf[Octet+Off] & 0x0f);
-                    Off++;
-                }
-            }
-            else
-            {
-                Q931SetError(pTrunk,Q931E_BEARERCAP, 7, Off);
-                return Q931E_BEARERCAP;
+	Q931SetIE(*pIE, *OOff);
 
-            }
-        }
-    }
-
-    Q931IESizeTest(Q931E_BEARERCAP);
-
-    Q931SetIE(*pIE, *OOff);
-
 	*IOff = (*IOff) + Octet + Off;
-    *OOff = (*OOff) + sizeof(Q931ie_BearerCap);
-    pie->Size = sizeof(Q931ie_BearerCap);
+	*OOff = (*OOff) + sizeof(Q931ie_BearerCap);
+	pie->Size = sizeof(Q931ie_BearerCap);
 
-    return Q931E_NO_ERROR;
+	return Q931E_NO_ERROR;
 }
 
 /*****************************************************************************
@@ -313,101 +306,102 @@
 
 L3INT Q931Pie_BearerCap(Q931_TrunkInfo_t *pTrunk, L3UCHAR *IBuf, L3UCHAR *OBuf, L3INT *Octet)
 {
-    Q931ie_BearerCap * pIE = (Q931ie_BearerCap*)IBuf;
-    L3INT rc=0;
-    L3INT Beg=*Octet;/* remember current offset */
-    L3INT li;
+	Q931ie_BearerCap * pIE = (Q931ie_BearerCap*)IBuf;
+	L3INT rc=0;
+	L3INT Beg=*Octet;/* remember current offset */
+	L3INT li;
 
-    OBuf[(*Octet)++] = Q931ie_BEARER_CAPABILITY ;
-    li=(*Octet)++;    /* remember length position */
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Encoding Bearer Capability IE\n");
 
-    /* Octet 3 - Coding standard / Information transfer capability */
-    OBuf[(*Octet)++] = 0x80 | (pIE->CodStand<<5) | (pIE->ITC & 0x1f);
+	OBuf[(*Octet)++] = Q931ie_BEARER_CAPABILITY ;
+	li=(*Octet)++;    /* remember length position */
 
-    /* Octet 4 - Transfer mode / Information transfer rate */
-	OBuf[(*Octet)++] = 0x80 | (pIE->TransMode<<5) | (pIE->ITR & 0x1f);
-    if(pIE->ITR == 0x18)
-    {
-        /* Octet 4.1 - Rate Multiplier */
-        OBuf[(*Octet)++] = 0x80 | pIE->RateMul;
-    }
+	/* Octet 3 - Coding standard / Information transfer capability */
+	OBuf[(*Octet)++] = 0x80 | ((pIE->CodStand << 5) & 0x60) | (pIE->ITC & 0x1f);
 
-    /* Octet 5 - Layer 1 Ident / User information layer 1 protocol*/
-    if(pIE->Layer1Ident == 0x01)
-    {
-        if(((pIE->ITC == 0x08) && (pIE->UIL1Prot == 0x01 || pIE->UIL1Prot == 0x08))
-        || ((pIE->ITC == 0x10) && (pIE->UIL1Prot == 0x02 || pIE->UIL1Prot == 0x03)))
-        {
-            OBuf[(*Octet)++] = 0x00 | (pIE->Layer1Ident<<5) | (pIE->UIL1Prot & 0x15);
+	/* Octet 4 - Transfer mode / Information transfer rate */
+	OBuf[(*Octet)++] = 0x80 | ((pIE->TransMode << 5) & 0x60) | (pIE->ITR & 0x1f);
+
+	if(pIE->ITR == 0x18)
+	{
+		/* Octet 4.1 - Rate Multiplier */
+		OBuf[(*Octet)++] = 0x80 | (pIE->RateMul & 0x7f);
+	}
+
+	/* Octet 5 - Layer 1 Ident / User information layer 1 protocol */
+	if(pIE->Layer1Ident == 0x01)
+	{
+		if(((pIE->ITC == 0x08) && (pIE->UIL1Prot == 0x01 || pIE->UIL1Prot == 0x08)) ||
+		   ((pIE->ITC == 0x10) && (pIE->UIL1Prot == 0x02 || pIE->UIL1Prot == 0x03)))
+		{
+			OBuf[(*Octet)++] = 0x00 | ((pIE->Layer1Ident << 5) & 0x60) | (pIE->UIL1Prot & 0x15);
             
-            /* Octet 5a - SyncAsync/Negot/UserRate */
-            OBuf[(*Octet)++] = 0x00 | (pIE->SyncAsync<<6) | (pIE->Negot<<5) | (pIE->UserRate&0x1f);
+			/* Octet 5a - SyncAsync/Negot/UserRate */
+			OBuf[(*Octet)++] = 0x00 | ((pIE->SyncAsync << 6) & 0x40) | ((pIE->Negot << 5) & 0x20) | (pIE->UserRate & 0x1f);
 
-            /* Octet 5b - one of two types */
-            if(pIE->UIL1Prot == 0x01) /* ITU V.110, I.460 and X.30           */
-            {
-                /* Octet 5b - Intermed rate/ Nic on Tx/Nix on Rx/FlowCtlTx/FlowCtlRx */
-                OBuf[(*Octet)++] = 0x00 
-                                | (pIE->InterRate<<6)
-                                | (pIE->NIConTx << 4)
-                                | (pIE->NIConRx << 3)
-                                | (pIE->FlowCtlTx << 2)
-                                | (pIE->FlowCtlRx << 1);
-            }
-            else if(pIE->UIL1Prot == 0x08) /* ITU V.120                      */
-            {
-                /* Octet 5b - HDR/Multiframe/Mode/LLINegot/Assignor/Inbandneg*/
-                OBuf[(*Octet)++] = 0x00
-                                | (pIE->InterRate << 6)
-                                | (pIE->MultiFrame << 5)
-                                | (pIE->Mode << 4)
-                                | (pIE->LLInegot << 3)
-                                | (pIE->Assignor << 2)
-                                | (pIE->InBandNeg << 1);
-            }
+			/* Octet 5b - one of two types */
+			if(pIE->UIL1Prot == 0x01) /* ITU V.110, I.460 and X.30           */
+			{
+				/* Octet 5b - Intermed rate/ Nic on Tx/Nix on Rx/FlowCtlTx/FlowCtlRx */
+				OBuf[(*Octet)++] = 0x00 
+						| ((pIE->InterRate << 6) & 0x60)
+						| ((pIE->NIConTx   << 4) & 0x10)
+						| ((pIE->NIConRx   << 3) & 0x08)
+						| ((pIE->FlowCtlTx << 2) & 0x04)
+						| ((pIE->FlowCtlRx << 1) & 0x02);
+			}
+			else if(pIE->UIL1Prot == 0x08) /* ITU V.120                      */
+			{
+				/* Octet 5b - HDR/Multiframe/Mode/LLINegot/Assignor/Inbandneg*/
+				OBuf[(*Octet)++] = 0x00
+						| ((pIE->InterRate  << 6) & 0x60)
+						| ((pIE->MultiFrame << 5) & 0x20)
+						| ((pIE->Mode       << 4) & 0x10)
+						| ((pIE->LLInegot   << 3) & 0x08)
+						| ((pIE->Assignor   << 2) & 0x04)
+						| ((pIE->InBandNeg  << 1) & 0x02);
+			}
 
-            /* Octet 5c - NumStopBits/NumStartBits/Parity                    */
-            OBuf[(*Octet)++] = 0x00 
-                            | (pIE->NumStopBits << 5 )
-                            | (pIE->NumDataBits << 3 )
-                            | (pIE->Parity);
+			/* Octet 5c - NumStopBits/NumStartBits/Parity                    */
+			OBuf[(*Octet)++] = 0x00 
+					| ((pIE->NumStopBits << 5) & 0x60)
+					| ((pIE->NumDataBits << 3) & 0x18)
+					| (pIE->Parity & 0x07);
 
-            /* Octet 5d - Duplex Mode/Modem Type */
-            OBuf[(*Octet)++] = 0x80 | (pIE->DuplexMode<<6) | (pIE->ModemType);
-        }
-        else
-        {
-            OBuf[(*Octet)++] = 0x80 | (pIE->Layer1Ident<<5) | (pIE->UIL1Prot & 0x1F);
-        }
-    }
+			/* Octet 5d - Duplex Mode/Modem Type */
+			OBuf[(*Octet)++] = 0x80 | ((pIE->DuplexMode << 6) & 0x40) | (pIE->ModemType & 0x3f);
+		}
+		else {
+			OBuf[(*Octet)++] = 0x80 | ((pIE->Layer1Ident << 5) & 0x60) | (pIE->UIL1Prot & 0x1f);
+		}
+	}
 
-    /* Octet 6 - Layer2Ident/User information layer 2 prtocol */
-    if(pIE->Layer2Ident == 0x02)
-    {
-        OBuf[(*Octet)++] = 0x80 | (pIE->Layer2Ident<<5) | (pIE->UIL2Prot);
-    }
+	/* Octet 6 - Layer2Ident/User information layer 2 prtocol */
+	if(pIE->Layer2Ident == 0x02) {
+		OBuf[(*Octet)++] = 0x80 | ((pIE->Layer2Ident << 5) & 0x60) | (pIE->UIL2Prot & 0x1f);
+	}
 
-    /* Octet 7 - Layer 3 Ident/ User information layer 3 protocol */
-    if(pIE->Layer3Ident == 0x03)
-    {
-        if(pIE->UIL3Prot == 0x0c)
-        {
-            OBuf[(*Octet)++] = 0x00 | (pIE->Layer3Ident<<5) | (pIE->UIL3Prot);
+	/* Octet 7 - Layer 3 Ident/ User information layer 3 protocol */
+	if(pIE->Layer3Ident == 0x03)
+	{
+		if(pIE->UIL3Prot == 0x0c)
+		{
+			OBuf[(*Octet)++] = 0x00 | ((pIE->Layer3Ident << 5) & 0x60) | (pIE->UIL3Prot & 0x1f);
 
-            /* Octet 7a - Additional information layer 3 msb */
-            OBuf[(*Octet)++] = 0x00 | (pIE->AL3Info1);
+			/* Octet 7a - Additional information layer 3 msb */
+			OBuf[(*Octet)++] = 0x00 | (pIE->AL3Info1 & 0x0f);
 
-            /* Octet 7b - Additional information layer 3 lsb */
-            OBuf[(*Octet)++] = 0x80 | (pIE->AL3Info2);
-        }
-        else
-        {
-            OBuf[(*Octet)++] = 0x80 | (pIE->Layer3Ident<<5) | (pIE->UIL3Prot);
-        }
-    }
+			/* Octet 7b - Additional information layer 3 lsb */
+			OBuf[(*Octet)++] = 0x80 | (pIE->AL3Info2 & 0x0f);
+		}
+		else {
+			OBuf[(*Octet)++] = 0x80 | ((pIE->Layer3Ident << 5) & 0x60) | (pIE->UIL3Prot & 0x1f);
+		}
+	}
 
-    OBuf[li] = (L3UCHAR)((*Octet)-Beg) - 2;
-    return rc;
+	OBuf[li] = (L3UCHAR)((*Octet)-Beg) - 2;
+
+	return rc;
 }
 
 /*****************************************************************************
@@ -1152,76 +1146,107 @@
 *****************************************************************************/
 L3INT Q931Uie_ChanID(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *pMsg, L3UCHAR * IBuf, L3UCHAR *OBuf, L3INT *IOff, L3INT *OOff)
 {
-    Q931ie_ChanID * pie = (Q931ie_ChanID*)OBuf;
+	Q931ie_ChanID *pie = (Q931ie_ChanID*)OBuf;
 	ie *pIE = &pMsg->ChanID;
-    L3INT Off = 0;
-    L3INT Octet = 0;
-    L3INT IESize;
+	L3INT Off = 0;
+	L3INT Octet = 0;
+	L3INT IESize;
 //18 04 e1 80 83 01
-    *pIE=0;
+	*pIE = 0;
 
-    /* Octet 1 */
-    pie->IEId        = IBuf[Octet];
-    Octet ++;
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Decoding Channel ID IE\n");
 
-    /* Octet 2 */
-    IESize = IBuf[Octet ++]; 
+	/* Octet 1 */
+	pie->IEId = IBuf[Octet++];
 
-    /* Octet 3 */
-    pie->IntIDPresent    = (IBuf[Octet] >> 6) & 0x01;
-    pie->IntType        = (IBuf[Octet] >> 5) & 0x01;
-    pie->PrefExcl        = (IBuf[Octet] >> 3) & 0x01;
-    pie->DChanInd        = (IBuf[Octet] >> 2) & 0x01;
-    pie->InfoChanSel    = IBuf[Octet] & 0x03;
+	/* Octet 2 */
+	IESize    = IBuf[Octet++]; 
 
-    Off = Q931ReadExt(&IBuf[Octet+Off], Off);
-    Octet++;
+	/* Octet 3 */
+	pie->IntIDPresent = (IBuf[Octet] >> 6) & 0x01;
+	pie->IntType      = (IBuf[Octet] >> 5) & 0x01;
+	pie->PrefExcl     = (IBuf[Octet] >> 3) & 0x01;
+	pie->DChanInd     = (IBuf[Octet] >> 2) & 0x01;
+	pie->InfoChanSel  =  IBuf[Octet] & 0x03;
 
-    /* Octet 3.1 */
+	Off = Q931ReadExt(&IBuf[Octet++], Off);
 
-    if(pie->IntIDPresent)
-    {
-        pie->InterfaceID    = IBuf[Octet+Off] & 0x7f;
+	/* Octet 3.1 */
+	if(pie->IntIDPresent)
+	{
+		pie->InterfaceID = IBuf[Octet+Off] & 0x7f;
 
-        /* Temp fix. Interface id can be extended using the extension bit */
-        /* this will read the octets, but do nothing with them. this is done */
-        /* because the usage of this field is a little unclear */
-        /* 30.jan.2001/JVB */
-        Off = Q931ReadExt(&IBuf[Octet+Off], Off);
-        Off++;
-    }
+		/* Temp fix. Interface id can be extended using the extension bit */
+		/* this will read the octets, but do nothing with them. this is done */
+		/* because the usage of this field is a little unclear */
+		/* 30.jan.2001/JVB */
+		Off = Q931ReadExt(&IBuf[Octet+Off], Off);
+		Off++;
+	}
 
-    if (Octet + Off -2 != IESize) {
-        /* Octet 3.2 */
-        if(pie->IntType == 1)        /* PRI etc */
-        {
-            pie->CodStand    = (IBuf[Octet + Off] >> 5) & 0x03;
-            pie->NumMap        = (IBuf[Octet + Off] >> 4) & 0x01;
-            pie->ChanMapType= IBuf[Octet + Off] & 0x0f;
+	if ((Octet + Off - 2) != IESize) {
+		/* Octet 3.2 */
+		if(pie->IntType == 1)        /* PRI etc */
+		{
+			pie->CodStand    = (IBuf[Octet + Off] >> 5) & 0x03;
+			pie->NumMap      = (IBuf[Octet + Off] >> 4) & 0x01;
+			pie->ChanMapType =  IBuf[Octet + Off] & 0x0f;
+			Off++;
 
-            Off ++;
+			/* Octet 3.3 */
+			/* TODO: Temp fix. Assume B channel. H channels not supported */
+			pie->ChanSlot = IBuf[Octet+Off] & 0x7f;
 
-
-            /* Octet 3.3 */
-            /* Temp fix. Assume B channel. H channels not supported */
-            pie->ChanSlot = IBuf[Octet+Off] & 0x7f;
 			/* Some dialects don't follow the extension coding properly for this, but this should be safe for all */
-			if (Octet + Off -1 != IESize) {
+			if (Octet + Off - 1 != IESize) {
 				Off = Q931ReadExt(&IBuf[Octet+Off], Off);
 			}
-            Off++;
-        }
-    }
+			Off++;
+		}
+	}
 
-    Q931IESizeTest(Q931E_CHANID);
+	Q931IESizeTest(Q931E_CHANID);
 
-    Q931SetIE(*pIE, *OOff);
+	Q931SetIE(*pIE, *OOff);
 
-    *IOff = (*IOff) + Octet + Off;
-    *OOff = (*OOff) + sizeof(Q931ie_BearerCap);
-    pie->Size = sizeof(Q931ie_BearerCap);
+	*IOff = (*IOff) + Octet + Off;
+	*OOff = (*OOff) + sizeof(Q931ie_BearerCap);
+	pie->Size = sizeof(Q931ie_BearerCap);
 
-    return Q931E_NO_ERROR;
+	if(pTrunk->loglevel == Q931_LOG_DEBUG)
+	{
+		const char *iface;
+		char tmp[100] = "";
+
+		if(!pie->IntType) {
+			switch(pie->InfoChanSel) {
+			case 0x0:
+				iface = "None";
+				break;
+			case 0x1:
+				iface = "B1";
+				break;
+			case 0x2:
+				iface = "B2";
+				break;
+			default:
+				iface = "Any Channel";
+			}
+
+			snprintf(tmp, sizeof(tmp)-1, "InfoChanSel: %d (%s)", pie->InfoChanSel, iface);
+		}
+
+		Q931Log(pTrunk, Q931_LOG_DEBUG,
+			"\n\n-------------------------- Q.931 Channel ID ------------------------\n"
+			"    Pref/Excl: %s, Interface Type: %s\n"
+			"    %s\n"
+			"--------------------------------------------------------------------\n\n",
+			((pie->PrefExcl) ? "Preferred" : "Exclusive"),
+			((pie->IntType) ? "PRI/Other" : "BRI"),
+			tmp);
+	}
+
+	return Q931E_NO_ERROR;
 }
 
 /*****************************************************************************
@@ -1237,43 +1262,52 @@
 *****************************************************************************/
 L3INT Q931Pie_ChanID(Q931_TrunkInfo_t *pTrunk, L3UCHAR *IBuf, L3UCHAR *OBuf, L3INT *Octet)
 {
-    Q931ie_ChanID * pIE = (Q931ie_ChanID*)IBuf;
-    L3INT rc=Q931E_NO_ERROR;
-    L3INT Beg=*Octet;/* remember current offset */
-    L3INT li;
+	Q931ie_ChanID * pIE = (Q931ie_ChanID*)IBuf;
+	L3INT rc = Q931E_NO_ERROR;
+	L3INT Beg = *Octet;	/* remember current offset */
+	L3INT li;
 
-    OBuf[(*Octet)++] = Q931ie_CHANNEL_IDENTIFICATION;
-    li=(*Octet)++;    /* remember length position */
+	OBuf[(*Octet)++] = Q931ie_CHANNEL_IDENTIFICATION;
+	li = (*Octet)++;	/* remember length position */
 
-    /* Octet 3 flags & BRI chan # */
-    OBuf[(*Octet)++] = 0x80 
-                    | (pIE->IntIDPresent << 6) 
-                    | (pIE->IntType<<5)
-                    | (pIE->PrefExcl<<3) 
-                    | pIE->InfoChanSel;
+	/* Octet 3 flags & BRI chan # */
+	OBuf[(*Octet)++] = 0x80 
+			| ((pIE->IntIDPresent << 6) & 0x40)
+			| ((pIE->IntType << 5) & 0x20)
+			| ((pIE->PrefExcl << 3) & 0x08)
+			|  (pIE->InfoChanSel & 0x03);
 
-    /* Octet 3.1 - Interface Identifier */
-    if(pIE->IntIDPresent)
-    {
-        OBuf[(*Octet)++] = 0x80 | pIE->InterfaceID;
-    }
-    else
-    {
-        /* Octet 3.2 & 3.3 - PRI */
-        if(pIE->IntType == 1)
-        {
-            OBuf[(*Octet)++]  = 0x80
-                            | (pIE->CodStand << 5)
-                            | (pIE->NumMap << 4)
-                            | pIE->ChanMapType;
+	/* Octet 3.1 - Interface Identifier */
+	if(pIE->IntIDPresent)
+	{
+		OBuf[(*Octet)++] = 0x80 | (pIE->InterfaceID & 0x7f);
+	}
+	else
+	{
+		/* Octet 3.2 & 3.3 - PRI */
+		if(pIE->IntType == 1)
+		{
+			OBuf[(*Octet)++] = 0x80
+					| ((pIE->CodStand << 5) & 0x60)
+					| ((pIE->NumMap << 4) & 0x10)
+					|  (pIE->ChanMapType & 0x0f);		/* TODO: support all possible channel map types */
 
-            /* Octet 3.2 Channel number/slot map */
-            OBuf[(*Octet)++] = 0x80 | pIE->ChanSlot;
-        }
-    }
+			/* Octet 3.3 Channel number */
+			switch(pIE->ChanMapType) {
+			case 0x6:	/* Slot map: H0 Channel Units */	/* unsupported, Octets 3.3.1 - 3.3.3 */
+				return Q931E_CHANID;
 
-    OBuf[li] = (L3UCHAR)((*Octet)-Beg) - 2;
-    return rc;
+			case 0x8:	/* Slot map: H11 Channel Units */
+			case 0x9:	/* Slot map: H12 Channel Units */
+			default:	/* Channel number */
+				OBuf[(*Octet)++] = 0x80 | (pIE->ChanSlot & 0x7f);
+				break;
+			}
+		}
+	}
+
+	OBuf[li] = (L3UCHAR)((*Octet)-Beg) - 2;
+	return rc;
 }
 
 
@@ -1302,30 +1336,29 @@
 *****************************************************************************/
 L3USHORT Q931Uie_CRV(Q931_TrunkInfo_t *pTrunk, L3UCHAR *IBuf, L3UCHAR *OBuf, L3INT *IOff, L3INT *OOff)
 {
+    L3USHORT CRV = 0;
     L3INT Octet = *IOff;
-    L3INT l = IBuf[Octet]; 
-    L3USHORT CRV;
-    Octet++; /*Octet 2 is length indicator */
+    L3INT l = IBuf[Octet++]; 
 
-    if(l == 1) /* One octet CRV */
+    if(l == 1)		/* One octet CRV */
     {
-        CRV = IBuf[Octet] & 0x7F;
-        Octet++;
+        CRV = IBuf[Octet++] & 0x7F;
     }
-    else if(l==2) /* two octet CRV */
+    else if(l == 2)	/* two octet CRV */
     {
-        CRV = (IBuf[Octet] & 0x7f) << 8;
-        CRV = CRV + IBuf[Octet+1];
-        Octet += 2;
+        CRV  = (IBuf[Octet++] & 0x7f) << 8;
+        CRV |=  IBuf[Octet++];
     }
     else
     {
-		/* Long CRV is not used, so we skip this */
-		/* TODO: is it right to set to 0 here? */
-		CRV = 0;
-        Octet+=l;
+	/* Long CRV is not used, so we skip this */
+	/* TODO: is it right to set to 0 here? */
+	CRV = 0;
+        Octet += l;
     }
 
+	Q931Log(pTrunk, Q931_LOG_DEBUG, "Call reference Value: %d (%#x)\n", CRV);
+
     *IOff = Octet;
     return CRV;
 }
@@ -1335,11 +1368,11 @@
   Function:     Q931Uie_DateTime
 
   Parameters:   pTrunk		[IN]		Ptr to trunk information.
-				pIE			[OUT]       ptr to Information Element id.
-                IBuf		[IN]        ptr to a packed ie.
-                OBuf		[OUT]       ptr to buffer for Unpacked ie.
-                IOff		[IN\OUT]    Input buffer offset
-                OOff		[IN\OUT]    Output buffer offset
+		pIE		[OUT]		ptr to Information Element id.
+                IBuf		[IN]		ptr to a packed ie.
+                OBuf		[OUT]		ptr to buffer for Unpacked ie.
+                IOff		[IN\OUT]	Input buffer offset
+                OOff		[IN\OUT]	Output buffer offset
 
                 Ibuf and OBuf points directly to buffers. The IOff and OOff
                 must be updated, but are otherwise not used in the ie unpack.
@@ -1349,65 +1382,64 @@
 *****************************************************************************/
 L3INT Q931Uie_DateTime(Q931_TrunkInfo_t *pTrunk, Q931mes_Generic *pMsg, L3UCHAR *IBuf, L3UCHAR *OBuf, L3INT *IOff, L3INT *OOff)
 {
-    Q931ie_DateTime * pie = (Q931ie_DateTime*)OBuf;
+	Q931ie_DateTime *pie = (Q931ie_DateTime*)OBuf;
 	ie *pIE = &pMsg->DateTime;
-    L3INT Off = 0;
-    L3INT Octet = 0;
-    L3INT IESize=0;
+	L3INT Off = 0;
+	L3INT Octet = 0;
+	L3INT IESize = 0;
+	*pIE=0;
 
-    *pIE=0;
+	/* Octet 1: ID */
+	pie->IEId  = IBuf[Octet++];
 
-    pie->IEId        = IBuf[Octet];
-    IESize = IBuf[Octet ++];
-    
-    /* Octet 2 */
-    IESize = IBuf[Octet ++]; 
+	/* Octet 2: Size */
+	IESize     = IBuf[Octet++]; 
 
-    /* Octet 3 - Year */
-    pie->Year = IBuf[Octet++];
+	/* Octet 3: Year */
+	pie->Year  = IBuf[Octet++];
 
-    /* Octet 4 - Month */
-    pie->Month = IBuf[Octet++];
+	/* Octet 4: Month */
+	pie->Month = IBuf[Octet++];
 
-    /* Octet 5 - Day */
-    pie->Day = IBuf[Octet++];
+	/* Octet 5: Day */
+	pie->Day   = IBuf[Octet++];
 
-    /*******************************************************************
-        The remaining part of the IE are optioinal, but only the length 
-        can now tell us wherever these fields are present or not
-    ********************************************************************/
-    pie->Format=0;
+	/*******************************************************************
+		The remaining part of the IE are optional, but only the length 
+		can now tell us wherever these fields are present or not
+	 ********************************************************************/
+	pie->Format=0;
 
-    /* Octet 6 - Hour (optional)*/
-    if(IESize >= 6)
-    {
-        pie->Format = 1;
-        pie->Hour = IBuf[Octet++];
+	/* Octet 6 - Hour (optional)*/
+	if(IESize >= 4)
+	{
+		pie->Format = 1;
+		pie->Hour = IBuf[Octet++];
+	}
 
-        /* Octet 7 - Minute (optional)*/
-        if(IESize >= 7)
-        {
-            pie->Format = 2;
-            pie->Minute = IBuf[Octet++];
+	/* Octet 7 - Minute (optional)*/
+	if(IESize >= 5)
+	{
+		pie->Format = 2;
+		pie->Minute = IBuf[Octet++];
+	}
 
-            /* Octet 8 - Second (optional)*/
-            if(IESize >= 8)
-            {
-                pie->Format = 3;
-                pie->Second = IBuf[Octet++];
-            }
-        }
-    }
+	/* Octet 8 - Second (optional)*/
+	if(IESize >= 6)
+	{
+		pie->Format = 3;
+		pie->Second = IBuf[Octet++];
+	}
 
-    Q931IESizeTest(Q931E_DATETIME);
+	Q931IESizeTest(Q931E_DATETIME);
 
-    Q931SetIE(*pIE, *OOff);
+	Q931SetIE(*pIE, *OOff);
 
-    *IOff = (*IOff) + Octet + Off;
-    *OOff = (*OOff) + sizeof(Q931ie_DateTime);
-    pie->Size = sizeof(Q931ie_DateTime);
+	*IOff = (*IOff) + Octet + Off;
+	*OOff = (*OOff) + sizeof(Q931ie_DateTime);
+	pie->Size = sizeof(Q931ie_DateTime);
 
-    return Q931E_NO_ERROR;
+	return Q931E_NO_ERROR;
 }
 
 /*****************************************************************************
